
_MP3_SCI_Write:

;mp3_player.c,62 :: 		void MP3_SCI_Write(char address, unsigned int data_in) {
;mp3_player.c,63 :: 		BSYNC = 1;
	PUSH	W10
	BSET	RG14_bit, #14
;mp3_player.c,65 :: 		MP3_CS = 0;                             // select MP3 SCI
	BCLR	RG12_bit, #12
;mp3_player.c,66 :: 		SPI2_Write(WRITE_CODE);
	PUSH	W10
	MOV	#2, W10
	CALL	_SPI2_Write
	POP	W10
;mp3_player.c,67 :: 		SPI2_Write(address);
	ZE	W10, W10
	CALL	_SPI2_Write
;mp3_player.c,68 :: 		SPI2_Write(Hi(data_in));                // high byte
	MOV	#lo_addr(W11), W0
	INC	W0
	ZE	[W0], W10
	CALL	_SPI2_Write
;mp3_player.c,69 :: 		SPI2_Write(Lo(data_in));                // low byte
	ZE	W11, W10
	CALL	_SPI2_Write
;mp3_player.c,70 :: 		MP3_CS = 1;                             // deselect MP3 SCI
	BSET	RG12_bit, #12
;mp3_player.c,71 :: 		while (DREQ == 0);                      // wait until DREQ becomes 1, see MP3 codec datasheet, Serial Protocol for SCI
L_MP3_SCI_Write0:
	BTSC	RG1_bit, #1
	GOTO	L_MP3_SCI_Write1
	GOTO	L_MP3_SCI_Write0
L_MP3_SCI_Write1:
;mp3_player.c,72 :: 		}
L_end_MP3_SCI_Write:
	POP	W10
	RETURN
; end of _MP3_SCI_Write

_MP3_SCI_Read:

;mp3_player.c,75 :: 		void MP3_SCI_Read(char start_address, char words_count, unsigned int *data_buffer) {
;mp3_player.c,78 :: 		BSYNC = 1;
	BSET	RG14_bit, #14
;mp3_player.c,80 :: 		MP3_CS = 0;                             // select MP3 SCI
	BCLR	RG12_bit, #12
;mp3_player.c,81 :: 		SPI2_Write(READ_CODE);
	PUSH	W10
	MOV	#3, W10
	CALL	_SPI2_Write
	POP	W10
;mp3_player.c,82 :: 		SPI2_Write(start_address);
	ZE	W10, W10
	CALL	_SPI2_Write
;mp3_player.c,84 :: 		while (words_count--) {                 // read words_count words byte per byte
L_MP3_SCI_Read2:
	MOV.B	W11, W1
	SUB.B	W11, #1, W0
	MOV.B	W0, W11
	CP0.B	W1
	BRA NZ	L__MP3_SCI_Read57
	GOTO	L_MP3_SCI_Read3
L__MP3_SCI_Read57:
;mp3_player.c,85 :: 		temp = SPI2_Read(0);
	PUSH	W10
	CLR	W10
	CALL	_SPI2_Read
;mp3_player.c,86 :: 		temp <<= 8;
	SL	W0, #8, W0
; temp start address is: 2 (W1)
	MOV	W0, W1
;mp3_player.c,87 :: 		temp += SPI2_Read(0);
	CLR	W10
	CALL	_SPI2_Read
	POP	W10
	ADD	W1, W0, [W12]
; temp end address is: 2 (W1)
;mp3_player.c,88 :: 		*(data_buffer++) = temp;
	ADD	W12, #2, W0
	MOV	W0, W12
;mp3_player.c,89 :: 		while (DREQ == 0);                      // wait until DREQ becomes 1, see MP3 codec datasheet, Serial Protocol for SCI
L_MP3_SCI_Read4:
	BTSC	RG1_bit, #1
	GOTO	L_MP3_SCI_Read5
	GOTO	L_MP3_SCI_Read4
L_MP3_SCI_Read5:
;mp3_player.c,90 :: 		}
	GOTO	L_MP3_SCI_Read2
L_MP3_SCI_Read3:
;mp3_player.c,91 :: 		MP3_CS = 1;                             // deselect MP3 SCI
	BSET	RG12_bit, #12
;mp3_player.c,93 :: 		}
L_end_MP3_SCI_Read:
	RETURN
; end of _MP3_SCI_Read

_MP3_SDI_Write:

;mp3_player.c,96 :: 		void MP3_SDI_Write(char data_) {
;mp3_player.c,98 :: 		MP3_CS = 1;
	BSET	RG12_bit, #12
;mp3_player.c,99 :: 		BSYNC = 0;
	BCLR	RG14_bit, #14
;mp3_player.c,101 :: 		while (DREQ == 0);                      // wait until DREQ becomes 1, see MP3 codec datasheet, Serial Protocol for SCI
L_MP3_SDI_Write6:
	BTSC	RG1_bit, #1
	GOTO	L_MP3_SDI_Write7
	GOTO	L_MP3_SDI_Write6
L_MP3_SDI_Write7:
;mp3_player.c,103 :: 		SPI2_Write(data_);
	ZE	W10, W10
	CALL	_SPI2_Write
;mp3_player.c,104 :: 		BSYNC = 1;
	BSET	RG14_bit, #14
;mp3_player.c,105 :: 		}
L_end_MP3_SDI_Write:
	RETURN
; end of _MP3_SDI_Write

_MP3_SDI_Write_32:

;mp3_player.c,108 :: 		void MP3_SDI_Write_32(char *data_) {
;mp3_player.c,111 :: 		MP3_CS = 1;
	BSET	RG12_bit, #12
;mp3_player.c,112 :: 		BSYNC = 0;
	BCLR	RG14_bit, #14
;mp3_player.c,114 :: 		while (DREQ == 0);                      // wait until DREQ becomes 1, see MP3 codec datasheet, Serial Protocol for SCI
L_MP3_SDI_Write_328:
	BTSC	RG1_bit, #1
	GOTO	L_MP3_SDI_Write_329
	GOTO	L_MP3_SDI_Write_328
L_MP3_SDI_Write_329:
;mp3_player.c,116 :: 		for (i=0; i<32; i++)
; i start address is: 2 (W1)
	CLR	W1
; i end address is: 2 (W1)
L_MP3_SDI_Write_3210:
; i start address is: 2 (W1)
	MOV.B	#32, W0
	CP.B	W1, W0
	BRA LTU	L__MP3_SDI_Write_3260
	GOTO	L_MP3_SDI_Write_3211
L__MP3_SDI_Write_3260:
;mp3_player.c,117 :: 		SPI2_Write(data_[i]);
	ZE	W1, W0
	ADD	W10, W0, W0
	PUSH	W10
	ZE	[W0], W10
	CALL	_SPI2_Write
	POP	W10
;mp3_player.c,116 :: 		for (i=0; i<32; i++)
	INC.B	W1
;mp3_player.c,117 :: 		SPI2_Write(data_[i]);
; i end address is: 2 (W1)
	GOTO	L_MP3_SDI_Write_3210
L_MP3_SDI_Write_3211:
;mp3_player.c,118 :: 		BSYNC = 1;
	BSET	RG14_bit, #14
;mp3_player.c,119 :: 		}
L_end_MP3_SDI_Write_32:
	RETURN
; end of _MP3_SDI_Write_32

_Set_Volume:

;mp3_player.c,122 :: 		void Set_Volume(char left,char right) {
;mp3_player.c,125 :: 		volume = (left<<8) + right;             // calculate value
	PUSH	W10
	PUSH	W11
	ZE	W10, W0
	SL	W0, #8, W1
	ZE	W11, W0
	ADD	W1, W0, W0
;mp3_player.c,126 :: 		MP3_SCI_Write(SCI_VOL_ADDR, volume);        // Write value to VOL register
	MOV	W0, W11
	MOV.B	#11, W10
	CALL	_MP3_SCI_Write
;mp3_player.c,127 :: 		}
L_end_Set_Volume:
	POP	W11
	POP	W10
	RETURN
; end of _Set_Volume

_MP3_Init:

;mp3_player.c,130 :: 		void MP3_Init() {
;mp3_player.c,135 :: 		UART2_Write_Line("Initializing VS1011E decoder interface");
	PUSH	W10
	PUSH	W11
	MOV	#lo_addr(?lstr1_mp3_player), W10
	CALL	_UART2_Write_Line
;mp3_player.c,139 :: 		BSYNC = 1;
	BSET	RG14_bit, #14
;mp3_player.c,140 :: 		MP3_CS = 1;
	BSET	RG12_bit, #12
;mp3_player.c,143 :: 		MP3_RST = 0;
	BCLR	RG13_bit, #13
;mp3_player.c,144 :: 		Delay_ms(10);
	MOV	#2, W8
	MOV	#41130, W7
L_MP3_Init13:
	DEC	W7
	BRA NZ	L_MP3_Init13
	DEC	W8
	BRA NZ	L_MP3_Init13
;mp3_player.c,145 :: 		MP3_RST = 1;
	BSET	RG13_bit, #13
;mp3_player.c,147 :: 		while (DREQ == 0);
L_MP3_Init15:
	BTSC	RG1_bit, #1
	GOTO	L_MP3_Init16
	GOTO	L_MP3_Init15
L_MP3_Init16:
;mp3_player.c,149 :: 		MP3_SCI_Write(SCI_MODE_ADDR, 0x0800);
	MOV	#2048, W11
	CLR	W10
	CALL	_MP3_SCI_Write
;mp3_player.c,150 :: 		MP3_SCI_Write(SCI_BASS_ADDR, 0x7A00);
	MOV	#31232, W11
	MOV.B	#2, W10
	CALL	_MP3_SCI_Write
;mp3_player.c,151 :: 		MP3_SCI_Write(SCI_CLOCKF_ADDR, 0x2000); // default 12 288 000 Hz
	MOV	#8192, W11
	MOV.B	#3, W10
	CALL	_MP3_SCI_Write
;mp3_player.c,154 :: 		volume_left  = 10;                      // Set volume to initial value
	MOV	#lo_addr(_volume_left), W1
	MOV.B	#10, W0
	MOV.B	W0, [W1]
;mp3_player.c,155 :: 		volume_right = 10;
	MOV	#lo_addr(_volume_right), W1
	MOV.B	#10, W0
	MOV.B	W0, [W1]
;mp3_player.c,156 :: 		Set_Volume(volume_left,volume_right);
	MOV.B	#10, W11
	MOV.B	#10, W10
	CALL	_Set_Volume
;mp3_player.c,157 :: 		}
L_end_MP3_Init:
	POP	W11
	POP	W10
	RETURN
; end of _MP3_Init

_Init_Sound:

;mp3_player.c,159 :: 		void Init_Sound() {
;mp3_player.c,160 :: 		ADPCFG = 0xFFFF;        // set all AN pins to digital
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
	MOV	#65535, W0
	MOV	WREG, ADPCFG
;mp3_player.c,162 :: 		MP3_CS_Direction  = 0;                  // Configure MP3_CS as output
	BCLR	TRISG12_bit, #12
;mp3_player.c,163 :: 		MP3_CS            = 1;                  // Deselect MP3_CS
	BSET	RG12_bit, #12
;mp3_player.c,164 :: 		MP3_RST_Direction = 0;                  // Configure MP3_RST as output
	BCLR	TRISG13_bit, #13
;mp3_player.c,165 :: 		MP3_RST           = 1;                  // Set MP3_RST pin
	BSET	RG13_bit, #13
;mp3_player.c,167 :: 		DREQ_Direction  = 1;                    // Configure DREQ as input
	BSET	TRISG1_bit, #1
;mp3_player.c,168 :: 		BSYNC_Direction = 0;                    // Configure BSYNC as output
	BCLR	TRISG14_bit, #14
;mp3_player.c,169 :: 		BSYNC           = 0;                    // Clear BSYNC
	BCLR	RG14_bit, #14
;mp3_player.c,170 :: 		BSYNC           = 1;                    // Clear BSYNC
	BSET	RG14_bit, #14
;mp3_player.c,172 :: 		UART2_Write_Line("Initializing SPI");
	MOV	#lo_addr(?lstr2_mp3_player), W10
	CALL	_UART2_Write_Line
;mp3_player.c,173 :: 		SPI2_Init_Advanced(_SPI_MASTER, _SPI_8_BIT, _SPI_PRESCALE_SEC_4, _SPI_PRESCALE_PRI_4,
	MOV	#2, W13
	MOV	#16, W12
	CLR	W11
	MOV	#32, W10
;mp3_player.c,174 :: 		_SPI_SS_DISABLE, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_HIGH, _SPI_ACTIVE_2_IDLE);
	CLR	W0
	PUSH	W0
	MOV	#64, W0
	PUSH	W0
	CLR	W0
	PUSH	W0
	CLR	W0
	PUSH	W0
	CALL	_SPI2_Init_Advanced
	SUB	#8, W15
;mp3_player.c,175 :: 		}
L_end_Init_Sound:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _Init_Sound

_Load_MP3_File:

;mp3_player.c,177 :: 		void Load_MP3_File(char *filename){
;mp3_player.c,179 :: 		UART2_Write_Line("Initializing MMC_FAT");
	PUSH	W10
	PUSH	W11
	PUSH	W10
	MOV	#lo_addr(?lstr3_mp3_player), W10
	CALL	_UART2_Write_Line
;mp3_player.c,182 :: 		current_pos = 0;
	CLR	W0
	CLR	W1
	MOV	W0, _current_pos
	MOV	W1, _current_pos+2
;mp3_player.c,184 :: 		if (Mmc_Fat_Init() == 0) {
	CALL	_Mmc_Fat_Init
	POP	W10
	CP.B	W0, #0
	BRA Z	L__Load_MP3_File65
	GOTO	L_Load_MP3_File17
L__Load_MP3_File65:
;mp3_player.c,185 :: 		if (Mmc_Fat_Assign(filename, 0) ) {
	PUSH	W10
	CLR	W11
	CALL	_Mmc_Fat_Assign
	POP	W10
	CP0.B	W0
	BRA NZ	L__Load_MP3_File66
	GOTO	L_Load_MP3_File18
L__Load_MP3_File66:
;mp3_player.c,186 :: 		UART2_Write_Line("Loaded MP3 File:");
	PUSH	W10
	MOV	#lo_addr(?lstr4_mp3_player), W10
	CALL	_UART2_Write_Line
	POP	W10
;mp3_player.c,187 :: 		UART2_Write_Line(filename);
	CALL	_UART2_Write_Line
;mp3_player.c,188 :: 		file_loaded = 1;
	MOV	#lo_addr(_file_loaded), W1
	MOV.B	#1, W0
	MOV.B	W0, [W1]
;mp3_player.c,189 :: 		}
	GOTO	L_Load_MP3_File19
L_Load_MP3_File18:
;mp3_player.c,191 :: 		UART2_Write_Line("Failed to load MP3 File: ");
	PUSH	W10
	MOV	#lo_addr(?lstr5_mp3_player), W10
	CALL	_UART2_Write_Line
	POP	W10
;mp3_player.c,192 :: 		UART2_Write_Line(filename);
	CALL	_UART2_Write_Line
;mp3_player.c,193 :: 		file_loaded = 0;
	MOV	#lo_addr(_file_loaded), W1
	CLR	W0
	MOV.B	W0, [W1]
;mp3_player.c,194 :: 		}
L_Load_MP3_File19:
;mp3_player.c,196 :: 		}
	GOTO	L_Load_MP3_File20
L_Load_MP3_File17:
;mp3_player.c,198 :: 		UART2_Write_Line("MMC FAT not initialized");
	MOV	#lo_addr(?lstr6_mp3_player), W10
	CALL	_UART2_Write_Line
;mp3_player.c,199 :: 		file_loaded = 0;
	MOV	#lo_addr(_file_loaded), W1
	CLR	W0
	MOV.B	W0, [W1]
;mp3_player.c,200 :: 		}
L_Load_MP3_File20:
;mp3_player.c,202 :: 		}
L_end_Load_MP3_File:
	POP	W11
	POP	W10
	RETURN
; end of _Load_MP3_File

_Play_MP3_Chunk:
	LNK	#4

;mp3_player.c,206 :: 		void Play_MP3_Chunk(){
;mp3_player.c,207 :: 		long starting_pos = 0;
	PUSH	W10
	PUSH	W11
;mp3_player.c,209 :: 		starting_pos = current_pos;
	MOV	_current_pos, W0
	MOV	_current_pos+2, W1
	MOV	W0, [W14+0]
	MOV	W1, [W14+2]
;mp3_player.c,212 :: 		if(!muteSound){
	MOV	#lo_addr(_muteSound), W0
	CP0	[W0]
	BRA Z	L__Play_MP3_Chunk68
	GOTO	L_Play_MP3_Chunk21
L__Play_MP3_Chunk68:
;mp3_player.c,214 :: 		if(file_loaded && ( file_size > current_pos)) {
	MOV	#lo_addr(_file_loaded), W0
	CP0.B	[W0]
	BRA NZ	L__Play_MP3_Chunk69
	GOTO	L__Play_MP3_Chunk54
L__Play_MP3_Chunk69:
	MOV	_file_size, W1
	MOV	_file_size+2, W2
	MOV	#lo_addr(_current_pos), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA GTU	L__Play_MP3_Chunk70
	GOTO	L__Play_MP3_Chunk53
L__Play_MP3_Chunk70:
L__Play_MP3_Chunk52:
;mp3_player.c,216 :: 		if(current_pos == 0){
	MOV	_current_pos, W0
	MOV	_current_pos+2, W1
	CP	W0, #0
	CPB	W1, #0
	BRA Z	L__Play_MP3_Chunk71
	GOTO	L_Play_MP3_Chunk25
L__Play_MP3_Chunk71:
;mp3_player.c,217 :: 		UART2_Write_Line("Play started.");
	MOV	#lo_addr(?lstr7_mp3_player), W10
	CALL	_UART2_Write_Line
;mp3_player.c,218 :: 		Mmc_Fat_Reset(&file_size);          // Call Reset before file reading,
	MOV	#lo_addr(_file_size), W10
	CALL	_Mmc_Fat_Reset
;mp3_player.c,220 :: 		UART2_Write_Line("File Size:");
	MOV	#lo_addr(?lstr8_mp3_player), W10
	CALL	_UART2_Write_Line
;mp3_player.c,221 :: 		UART2_Write_Long_Variable(file_size);
	MOV	_file_size, W10
	MOV	_file_size+2, W11
	CALL	_UART2_Write_Long_Variable
;mp3_player.c,222 :: 		play_next_song = 0;
	CLR	W0
	MOV	W0, _play_next_song
;mp3_player.c,224 :: 		unable_to_play = 0;
	CLR	W0
	CLR	W1
	MOV	W0, _unable_to_play
	MOV	W1, _unable_to_play+2
;mp3_player.c,225 :: 		}
L_Play_MP3_Chunk25:
;mp3_player.c,228 :: 		while( (current_pos - starting_pos) < (BUFFER_SIZE) ){
L_Play_MP3_Chunk26:
	MOV	_current_pos, W4
	MOV	_current_pos+2, W5
	ADD	W14, #0, W0
	SUB	W4, [W0++], W2
	SUBB	W5, [W0--], W3
	MOV	#512, W0
	MOV	#0, W1
	CP	W2, W0
	CPB	W3, W1
	BRA LT	L__Play_MP3_Chunk72
	GOTO	L_Play_MP3_Chunk27
L__Play_MP3_Chunk72:
;mp3_player.c,230 :: 		for (i=0; i<BUFFER_SIZE; i++) {
	CLR	W0
	CLR	W1
	MOV	W0, _i
	MOV	W1, _i+2
L_Play_MP3_Chunk28:
	MOV	#512, W1
	MOV	#0, W2
	MOV	#lo_addr(_i), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA GTU	L__Play_MP3_Chunk73
	GOTO	L_Play_MP3_Chunk29
L__Play_MP3_Chunk73:
;mp3_player.c,231 :: 		Mmc_Fat_Read(BufferLarge + i);
	MOV	#lo_addr(_BufferLarge), W1
	MOV	#lo_addr(_i), W0
	ADD	W1, [W0], W0
	MOV	W0, W10
	CALL	_Mmc_Fat_Read
;mp3_player.c,230 :: 		for (i=0; i<BUFFER_SIZE; i++) {
	MOV	#1, W1
	MOV	#0, W2
	MOV	#lo_addr(_i), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;mp3_player.c,232 :: 		}
	GOTO	L_Play_MP3_Chunk28
L_Play_MP3_Chunk29:
;mp3_player.c,234 :: 		for (i=0; i<BUFFER_SIZE/32; i++) {
	CLR	W0
	CLR	W1
	MOV	W0, _i
	MOV	W1, _i+2
L_Play_MP3_Chunk31:
	MOV	_i, W0
	MOV	_i+2, W1
	CP	W0, #16
	CPB	W1, #0
	BRA LTU	L__Play_MP3_Chunk74
	GOTO	L_Play_MP3_Chunk32
L__Play_MP3_Chunk74:
;mp3_player.c,235 :: 		MP3_SDI_Write_32(BufferLarge + i*32);
	MOV	#5, W3
	MOV	#lo_addr(_i), W0
	MOV	[W0++], W1
	MOV	[W0--], W2
L__Play_MP3_Chunk75:
	DEC	W3, W3
	BRA LT	L__Play_MP3_Chunk76
	SL	W1, W1
	RLC	W2, W2
	BRA	L__Play_MP3_Chunk75
L__Play_MP3_Chunk76:
	MOV	#lo_addr(_BufferLarge), W0
	ADD	W0, W1, W0
	MOV	W0, W10
	CALL	_MP3_SDI_Write_32
;mp3_player.c,234 :: 		for (i=0; i<BUFFER_SIZE/32; i++) {
	MOV	#1, W1
	MOV	#0, W2
	MOV	#lo_addr(_i), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;mp3_player.c,236 :: 		}
	GOTO	L_Play_MP3_Chunk31
L_Play_MP3_Chunk32:
;mp3_player.c,238 :: 		current_pos += BUFFER_SIZE;
	MOV	#512, W1
	MOV	#0, W2
	MOV	#lo_addr(_current_pos), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;mp3_player.c,243 :: 		}
	GOTO	L_Play_MP3_Chunk26
L_Play_MP3_Chunk27:
;mp3_player.c,249 :: 		}
	GOTO	L_Play_MP3_Chunk34
;mp3_player.c,214 :: 		if(file_loaded && ( file_size > current_pos)) {
L__Play_MP3_Chunk54:
L__Play_MP3_Chunk53:
;mp3_player.c,253 :: 		if(unable_to_play < 3){
	MOV	_unable_to_play, W0
	MOV	_unable_to_play+2, W1
	CP	W0, #3
	CPB	W1, #0
	BRA LT	L__Play_MP3_Chunk77
	GOTO	L_Play_MP3_Chunk35
L__Play_MP3_Chunk77:
;mp3_player.c,254 :: 		UART2_Write_Line("Unable to play MP3 file.");
	MOV	#lo_addr(?lstr9_mp3_player), W10
	CALL	_UART2_Write_Line
;mp3_player.c,255 :: 		}
L_Play_MP3_Chunk35:
;mp3_player.c,257 :: 		current_pos = 0;
	CLR	W0
	CLR	W1
	MOV	W0, _current_pos
	MOV	W1, _current_pos+2
;mp3_player.c,258 :: 		file_loaded = 0;
	MOV	#lo_addr(_file_loaded), W1
	CLR	W0
	MOV.B	W0, [W1]
;mp3_player.c,259 :: 		play_next_song = 1;
	MOV	#1, W0
	MOV	W0, _play_next_song
;mp3_player.c,260 :: 		song_count++;
	MOV	#1, W1
	MOV	#lo_addr(_song_count), W0
	ADD	W1, [W0], [W0]
;mp3_player.c,262 :: 		unable_to_play++;
	MOV	#1, W1
	MOV	#0, W2
	MOV	#lo_addr(_unable_to_play), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;mp3_player.c,263 :: 		}
L_Play_MP3_Chunk34:
;mp3_player.c,264 :: 		}
L_Play_MP3_Chunk21:
;mp3_player.c,266 :: 		}
L_end_Play_MP3_Chunk:
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _Play_MP3_Chunk

_Play_MP3:

;mp3_player.c,276 :: 		void Play_MP3(){
;mp3_player.c,278 :: 		if(file_loaded) {
	PUSH	W10
	MOV	#lo_addr(_file_loaded), W0
	CP0.B	[W0]
	BRA NZ	L__Play_MP379
	GOTO	L_Play_MP336
L__Play_MP379:
;mp3_player.c,280 :: 		UART2_Write_Line("Play started.");
	MOV	#lo_addr(?lstr10_mp3_player), W10
	CALL	_UART2_Write_Line
;mp3_player.c,281 :: 		Mmc_Fat_Reset(&file_size);          // Call Reset before file reading,
	MOV	#lo_addr(_file_size), W10
	CALL	_Mmc_Fat_Reset
;mp3_player.c,284 :: 		while (file_size > BUFFER_SIZE) {
L_Play_MP337:
	MOV	#512, W1
	MOV	#0, W2
	MOV	#lo_addr(_file_size), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA LTU	L__Play_MP380
	GOTO	L_Play_MP338
L__Play_MP380:
;mp3_player.c,286 :: 		for (i=0; i<BUFFER_SIZE; i++) {
	CLR	W0
	CLR	W1
	MOV	W0, _i
	MOV	W1, _i+2
L_Play_MP339:
	MOV	#512, W1
	MOV	#0, W2
	MOV	#lo_addr(_i), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA GTU	L__Play_MP381
	GOTO	L_Play_MP340
L__Play_MP381:
;mp3_player.c,287 :: 		Mmc_Fat_Read(BufferLarge + i);
	MOV	#lo_addr(_BufferLarge), W1
	MOV	#lo_addr(_i), W0
	ADD	W1, [W0], W0
	MOV	W0, W10
	CALL	_Mmc_Fat_Read
;mp3_player.c,286 :: 		for (i=0; i<BUFFER_SIZE; i++) {
	MOV	#1, W1
	MOV	#0, W2
	MOV	#lo_addr(_i), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;mp3_player.c,288 :: 		}
	GOTO	L_Play_MP339
L_Play_MP340:
;mp3_player.c,290 :: 		for (i=0; i<BUFFER_SIZE/32; i++) {
	CLR	W0
	CLR	W1
	MOV	W0, _i
	MOV	W1, _i+2
L_Play_MP342:
	MOV	_i, W0
	MOV	_i+2, W1
	CP	W0, #16
	CPB	W1, #0
	BRA LTU	L__Play_MP382
	GOTO	L_Play_MP343
L__Play_MP382:
;mp3_player.c,291 :: 		MP3_SDI_Write_32(BufferLarge + i*32);
	MOV	#5, W3
	MOV	#lo_addr(_i), W0
	MOV	[W0++], W1
	MOV	[W0--], W2
L__Play_MP383:
	DEC	W3, W3
	BRA LT	L__Play_MP384
	SL	W1, W1
	RLC	W2, W2
	BRA	L__Play_MP383
L__Play_MP384:
	MOV	#lo_addr(_BufferLarge), W0
	ADD	W0, W1, W0
	MOV	W0, W10
	CALL	_MP3_SDI_Write_32
;mp3_player.c,290 :: 		for (i=0; i<BUFFER_SIZE/32; i++) {
	MOV	#1, W1
	MOV	#0, W2
	MOV	#lo_addr(_i), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;mp3_player.c,292 :: 		}
	GOTO	L_Play_MP342
L_Play_MP343:
;mp3_player.c,294 :: 		file_size -= BUFFER_SIZE;
	MOV	#512, W1
	MOV	#0, W2
	MOV	#lo_addr(_file_size), W0
	SUBR	W1, [W0], [W0++]
	SUBBR	W2, [W0], [W0--]
;mp3_player.c,299 :: 		}
	GOTO	L_Play_MP337
L_Play_MP338:
;mp3_player.c,302 :: 		for (i=0; i<file_size; i++) {
	CLR	W0
	CLR	W1
	MOV	W0, _i
	MOV	W1, _i+2
L_Play_MP345:
	MOV	_i, W1
	MOV	_i+2, W2
	MOV	#lo_addr(_file_size), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA LTU	L__Play_MP385
	GOTO	L_Play_MP346
L__Play_MP385:
;mp3_player.c,303 :: 		Mmc_Fat_Read(BufferLarge + i);
	MOV	#lo_addr(_BufferLarge), W1
	MOV	#lo_addr(_i), W0
	ADD	W1, [W0], W0
	MOV	W0, W10
	CALL	_Mmc_Fat_Read
;mp3_player.c,302 :: 		for (i=0; i<file_size; i++) {
	MOV	#1, W1
	MOV	#0, W2
	MOV	#lo_addr(_i), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;mp3_player.c,304 :: 		}
	GOTO	L_Play_MP345
L_Play_MP346:
;mp3_player.c,305 :: 		for (i=0; i<file_size; i++) {
	CLR	W0
	CLR	W1
	MOV	W0, _i
	MOV	W1, _i+2
L_Play_MP348:
	MOV	_i, W1
	MOV	_i+2, W2
	MOV	#lo_addr(_file_size), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA LTU	L__Play_MP386
	GOTO	L_Play_MP349
L__Play_MP386:
;mp3_player.c,306 :: 		MP3_SDI_Write(BufferLarge[i]);
	MOV	#lo_addr(_BufferLarge), W1
	MOV	#lo_addr(_i), W0
	ADD	W1, [W0], W0
	MOV.B	[W0], W10
	CALL	_MP3_SDI_Write
;mp3_player.c,305 :: 		for (i=0; i<file_size; i++) {
	MOV	#1, W1
	MOV	#0, W2
	MOV	#lo_addr(_i), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;mp3_player.c,307 :: 		}
	GOTO	L_Play_MP348
L_Play_MP349:
;mp3_player.c,310 :: 		UART2_Write_Line("Play finished.");
	MOV	#lo_addr(?lstr11_mp3_player), W10
	CALL	_UART2_Write_Line
;mp3_player.c,311 :: 		}
	GOTO	L_Play_MP351
L_Play_MP336:
;mp3_player.c,314 :: 		UART2_Write_Line("Unable to play MP3 file.");
	MOV	#lo_addr(?lstr12_mp3_player), W10
	CALL	_UART2_Write_Line
;mp3_player.c,315 :: 		}
L_Play_MP351:
;mp3_player.c,317 :: 		}
L_end_Play_MP3:
	POP	W10
	RETURN
; end of _Play_MP3
