#line 1 "C:/Documents and Settings/PC/Desktop/mikromedia winter dev/Snowburst/Development/snowburst code/mp3_player.c"
#line 1 "c:/program files/mikroelektronika/mikroc pro for dspic/include/built_in.h"
#line 7 "C:/Documents and Settings/PC/Desktop/mikromedia winter dev/Snowburst/Development/snowburst code/mp3_player.c"
extern void UART2_Write_Line(char *uart_text);
extern void UART2_Write_Long_Variable(long var);


sbit Mmc_Chip_Select at LATG9_bit;
sbit MP3_CS at RG12_bit;
sbit MP3_RST at RG13_bit;
sbit DREQ at RG1_bit;
sbit BSYNC at RG14_bit;

sbit Mmc_Chip_Select_Direction at TRISG9_bit;
sbit MP3_CS_Direction at TRISG12_bit;
sbit MP3_RST_Direction at TRISG13_bit;
sbit DREQ_Direction at TRISG1_bit;
sbit BSYNC_Direction at TRISG14_bit;


const char WRITE_CODE = 0x02;
const char READ_CODE = 0x03;
const char SCI_MODE_ADDR = 0x00;
const char SCI_CLOCKF_ADDR = 0x03;
const char SCI_VOL_ADDR = 0x0B;
const char SCI_BASS_ADDR = 0x02;

char data_buffer_32[32];
char volume_left, volume_right;
unsigned long i, file_size;


extern int muteSound;



const BUFFER_SIZE = 512;
char BufferLarge[BUFFER_SIZE];


char file_loaded = 0;


long current_pos = 0;


int play_next_song = 0;


int song_count = 0;

long unable_to_play = 0;


extern void UART2_Write_Line (char *text);
extern void UART2_Write_Long_Variable(long var);


void MP3_SCI_Write(char address, unsigned int data_in) {
 BSYNC = 1;

 MP3_CS = 0;
 SPI2_Write(WRITE_CODE);
 SPI2_Write(address);
 SPI2_Write( ((char *)&data_in)[1] );
 SPI2_Write( ((char *)&data_in)[0] );
 MP3_CS = 1;
 while (DREQ == 0);
}


void MP3_SCI_Read(char start_address, char words_count, unsigned int *data_buffer) {
 unsigned int temp;

 BSYNC = 1;

 MP3_CS = 0;
 SPI2_Write(READ_CODE);
 SPI2_Write(start_address);

 while (words_count--) {
 temp = SPI2_Read(0);
 temp <<= 8;
 temp += SPI2_Read(0);
 *(data_buffer++) = temp;
 while (DREQ == 0);
 }
 MP3_CS = 1;

}


void MP3_SDI_Write(char data_) {

 MP3_CS = 1;
 BSYNC = 0;

 while (DREQ == 0);

 SPI2_Write(data_);
 BSYNC = 1;
}


void MP3_SDI_Write_32(char *data_) {
 char i;

 MP3_CS = 1;
 BSYNC = 0;

 while (DREQ == 0);

 for (i=0; i<32; i++)
 SPI2_Write(data_[i]);
 BSYNC = 1;
}


void Set_Volume(char left,char right) {
 unsigned int volume;

 volume = (left<<8) + right;
 MP3_SCI_Write(SCI_VOL_ADDR, volume);
}


void MP3_Init() {




 UART2_Write_Line("Initializing VS1011E decoder interface");



 BSYNC = 1;
 MP3_CS = 1;


 MP3_RST = 0;
 Delay_ms(10);
 MP3_RST = 1;

 while (DREQ == 0);

 MP3_SCI_Write(SCI_MODE_ADDR, 0x0800);
 MP3_SCI_Write(SCI_BASS_ADDR, 0x7A00);
 MP3_SCI_Write(SCI_CLOCKF_ADDR, 0x2000);


 volume_left = 10;
 volume_right = 10;
 Set_Volume(volume_left,volume_right);
}

void Init_Sound() {
 ADPCFG = 0xFFFF;

 MP3_CS_Direction = 0;
 MP3_CS = 1;
 MP3_RST_Direction = 0;
 MP3_RST = 1;

 DREQ_Direction = 1;
 BSYNC_Direction = 0;
 BSYNC = 0;
 BSYNC = 1;

 UART2_Write_Line("Initializing SPI");
 SPI2_Init_Advanced(_SPI_MASTER, _SPI_8_BIT, _SPI_PRESCALE_SEC_4, _SPI_PRESCALE_PRI_4,
 _SPI_SS_DISABLE, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_HIGH, _SPI_ACTIVE_2_IDLE);
}

void Load_MP3_File(char *filename){

 UART2_Write_Line("Initializing MMC_FAT");


 current_pos = 0;

 if (Mmc_Fat_Init() == 0) {
 if (Mmc_Fat_Assign(filename, 0) ) {
 UART2_Write_Line("Loaded MP3 File:");
 UART2_Write_Line(filename);
 file_loaded = 1;
 }
 else {
 UART2_Write_Line("Failed to load MP3 File: ");
 UART2_Write_Line(filename);
 file_loaded = 0;
 }

 }
 else {
 UART2_Write_Line("MMC FAT not initialized");
 file_loaded = 0;
 }

}



void Play_MP3_Chunk(){
long starting_pos = 0;

starting_pos = current_pos;


if(!muteSound){

 if(file_loaded && ( file_size > current_pos)) {

 if(current_pos == 0){
 UART2_Write_Line("Play started.");
 Mmc_Fat_Reset(&file_size);

 UART2_Write_Line("File Size:");
 UART2_Write_Long_Variable(file_size);
 play_next_song = 0;

 unable_to_play = 0;
 }


 while( (current_pos - starting_pos) < (BUFFER_SIZE) ){

 for (i=0; i<BUFFER_SIZE; i++) {
 Mmc_Fat_Read(BufferLarge + i);
 }

 for (i=0; i<BUFFER_SIZE/32; i++) {
 MP3_SDI_Write_32(BufferLarge + i*32);
 }

 current_pos += BUFFER_SIZE;




 }





 }
 else{


 if(unable_to_play < 3){
 UART2_Write_Line("Unable to play MP3 file.");
 }

 current_pos = 0;
 file_loaded = 0;
 play_next_song = 1;
 song_count++;

 unable_to_play++;
 }
 }

}









void Play_MP3(){

 if(file_loaded) {

 UART2_Write_Line("Play started.");
 Mmc_Fat_Reset(&file_size);


 while (file_size > BUFFER_SIZE) {

 for (i=0; i<BUFFER_SIZE; i++) {
 Mmc_Fat_Read(BufferLarge + i);
 }

 for (i=0; i<BUFFER_SIZE/32; i++) {
 MP3_SDI_Write_32(BufferLarge + i*32);
 }

 file_size -= BUFFER_SIZE;




 }


 for (i=0; i<file_size; i++) {
 Mmc_Fat_Read(BufferLarge + i);
 }
 for (i=0; i<file_size; i++) {
 MP3_SDI_Write(BufferLarge[i]);
 }


 UART2_Write_Line("Play finished.");
 }
 else{

 UART2_Write_Line("Unable to play MP3 file.");
 }

}
